#include "atmodels.h"
#include "jac77.h"

void main()
{
	static double h, an[6], wmol, rhod, rjud, dafr, gsti;
	static double sa[3], su[2], sf[3], te[2];
	static int i, j;
	static int t[5] = {500, 700, 1000, 1500, 2400};
	static int rl[5] = {-60, -30, 0, 30, 60};
	
	FILE *nfil;

	nfil = fopen("j7profc.dat", "w");
	printf (" ******************************** Static Profile *******************************\n");
	printf ("                             Exospheric Temperature \n\n");
	printf (" alt           500K           700K          1000K          1500K          2400K\n");
	printf ("(km) mmolms logdsty mmolms logdsty mmolms logdsty mmolms logdsty mmolms logdsty\n");
	fprintf(nfil, " ******************************************************************************\n");
	fprintf(nfil, "                                Jacchia 77 Model\n");
	fprintf(nfil, " \n******************************** Static Profile *******************************\n");
	fprintf(nfil, "                             Exospheric Temperature \n\n");
	fprintf(nfil, " alt           500K           700K          1000K          1500K          2400K\n");
	fprintf(nfil, "(km) mmolms logdsty mmolms logdsty mmolms logdsty mmolms logdsty mmolms logdsty\n");

	for (h = 90; h <= 2000; h+=10)
	{
		printf("%4d", int(h)); 
		fprintf(nfil, "%4d", int(h)); 
		for (i = 0; i < 5; i++)
		{
			imowei(double(t[i]), h, an, &wmol, &rhod);
			printf(" %6.2f %7.3f", wmol, log10(rhod)); 
			fprintf(nfil, " %6.2f %7.3f", wmol, log10(rhod)); 
		}
		printf("\n");
		fprintf(nfil, "\n");
	}

	fclose(nfil);
	
	nfil = fopen("j7statc.dat", "w");
	sf[0] = 100.;
	sf[1] = 100.;
	printf ("\n\n ************************ Static Model - Solar Cycle ***********************\n\n");
	printf ("                         F10.7 = %6.2f Fbar = %6.2f \n",
		sf[0], sf[1]);
	printf ("  Alt MMolMs LogDsty ExTemp LcTemp NMolHe NMolO2 NMolN2 NMolAr NMmolO  NMolH\n");
	fprintf(nfil, " ******************************************************************************\n");
	fprintf(nfil, "                                Jacchia 77 Model\n");
	fprintf(nfil,"\n\n ************************ Static Model - Solar Cycle ***********************\n\n");
	fprintf(nfil,"                         F10.7 = %6.2f Fbar = %6.2f \n",
		sf[0], sf[1]);
	fprintf(nfil,"  Alt MMolMs LogDsty ExTemp LcTemp NMolHe NMolO2 NMolN2 NMolAr NMmolO  NMolH\n");
	for (h = 90; h <= 2000; h+=10)
	{
		ismade(h*1000., sf, te, an, &wmol, &rhod);
		printf (" %4d %6.2f%8.3f%7.2f%7.2f%7.3f%7.3f%7.3f%7.3f%7.3f%7.3f\n",
			int(h), wmol, log10(rhod), te[0], te[1],
			an[0], an[1], an[2], an[3], an[4], an[5]);
		fprintf(nfil," %4d %6.2f%8.3f%7.2f%7.2f%7.3f%7.3f%7.3f%7.3f%7.3f%7.3f\n",
			int(h), wmol, log10(rhod), te[0], te[1],
			an[0], an[1], an[2], an[3], an[4], an[5]);
	}

	fclose(nfil);

	nfil = fopen("j7dynmc.dat", "w");
	sf[0] = 100.;
	sf[1] = 100.;
	sf[2] = 5.;
	sa[0] = 0.;
	sa[1] = 0.;
	sa[2] = 600000.;
	su[0] = 0.;
	su[1] = 0.;
	rjud  = 22476.;
	dafr  = 0.;
	gsti  = 293.49/180.*3.141592;
	printf("\n\n ******************************** Dynamic Model ");
	printf("*******************************\n F10.7 = %6.2f, Fbar = %6.2f,",
		sf[0], sf[1]);
	printf(" Kp = %3.1f, Right ascension (deg) = %6.2f, \n", sf[2], sa[0]);
	printf(" Greenwich Sederal Time (rad) = %8.3f, Altitude (km) = %6.2f, \n",
		gsti, sa[2]/1000.);
	printf(" Modified Julian Date = %6.0f, UTC (s) = %9.3f\n\n", rjud, dafr);
	printf("                                  Latitude (deg) \n");
	printf("SunRA    %4d           %4d           %4d           %4d           %4d \n",
		int(rl[0]), int(rl[1]), int(rl[2]), int(rl[3]), int(rl[4]), int(rl[5]));
	printf(" deg mmolms logdsty mmolms logdsty mmolms logdsty mmolms logdsty mmolms logdsty\n");
	fprintf(nfil, " ******************************************************************************\n");
	fprintf(nfil, "                                Jacchia 77 Model\n");
	fprintf(nfil,"\n\n ******************************** Dynamic Model ");
	fprintf(nfil,"*******************************\n F10.7 = %6.2f, Fbar = %6.2f,",
		sf[0], sf[1]);
	fprintf(nfil," Kp = %3.1f, Right ascension (deg) = %6.2f, \n", sf[2], sa[0]);
	fprintf(nfil," Greenwich Sederal Time (rad) = %8.3f, Altitude (km) = %6.2f, \n",
		gsti, sa[2]/1000.);
	fprintf(nfil," Modified Julian Date = %6.0f, UTC (s) = %9.3f\n\n", rjud, dafr);
	fprintf(nfil,"                                  Latitude (deg) \n");
	fprintf(nfil,"SunRA    %4d           %4d           %4d           %4d           %4d \n",
		int(rl[0]), int(rl[1]), int(rl[2]), int(rl[3]), int(rl[4]), int(rl[5])) ;
	fprintf(nfil," deg mmolms logdsty mmolms logdsty mmolms logdsty mmolms logdsty mmolms logdsty\n");
	for (h = -180; h <= 180; h+=5)
	{
		sa[0] = h*3.141592/180.;
		printf("%4d", int(h)); 
		fprintf(nfil, "%4d", int(h)); 
		for (i = 0; i < 5; i++)
		{
			sa[1] = rl[i]*3.141592/180.;
			isdamo(sa, su, sf, rjud, dafr, gsti, te, an, &wmol, &rhod);
			printf(" %6.2f%8.3f", wmol, log10(rhod));
			fprintf(nfil, " %6.2f%8.3f", wmol, log10(rhod));
		}
		printf("\n");
		fprintf(nfil, "\n");
	}
	fclose(nfil);


	return;
}